#include <stdio.h>
#include "mpi.h"
#include <math.h>
float f(float a, float b);
#define N 32 /* Total data number */
void main(int argc, char* argv[])
{
   float x[N], y[N];
   /* this is used to temporarily store the data sent from other process*/
   float myY[N];
   int my_rank;
   /* Number of processes */
   int p;
   /* Number of values I need to calculate */
   int n;
   /* temporary counters */
   int i, j, k;
   MPI_Status status;
   /* The array to save the correlation*/
   float correlation[N];
   /* We use it to store the summation of each process and the total sume*/
   float sum = 0.0, finalsum = 0.0;

   /* Start up MPI */
   MPI_Init(&argc, &argv);

   /* Find out process rank */
   MPI_Comm_rank(MPI_COMM_WORLD, &my_rank);
   /* Find out number of processes */
   MPI_Comm_size(MPI_COMM_WORLD, &p);

   /* initialize the data, this could be replaced by reading from an
      existing data file or from command line. */
#if 0
   srand48( my_rank * p * N);
#endif

   srand48(N);
   
   for( i = 0; i < N/p; i++)
     {  x[i] = drand48();
        y[i] = drand48();
     
      myY[i] = 0.0;
      correlation[i] = 0.0;      
   }

#if 0
   printf("Init X values are:\n");
   for(i = 0; i < N/p; i++)
      printf("%e\t", x[i]);
   printf("\n");
   
   printf("\nInit Y values are:\n");
   for(i = 0; i < N/p; i++)
      printf("%e\t", y[i]);
   printf("\n");
#endif

   /* I need to work on this number of values */
   n = N / p;

   for ( k=0; k<p; k++ ) 
   {  for ( j = 0; j<n; j++ )
         for (i = 0; i<n; i++ )
            correlation[i] += f( x[i], y[j] );
      /* send my Y values to process with rank 1 greater than me, 
         receive Y values from proecess with rank 1 smaller than me. 
         Wrap around when meeting the 0 or p-1 process. */
      MPI_Sendrecv(&y, (N/p), MPI_FLOAT, (my_rank+1)%p, 1, &myY, (N/p),
         MPI_FLOAT, (my_rank + p - 1) %p, 1, MPI_COMM_WORLD, &status);

      /* Store the received data in y array.*/
      for(i = 0; i < n; i++)
         y[i] = myY[i];
   }
   /* compute summation of this process */
   for(i = 0; i < n; i++)
      sum += correlation[i];

   /* Reduce to process 0 */
   MPI_Reduce( &sum, &finalsum, 1, MPI_FLOAT, MPI_SUM, 0, MPI_COMM_WORLD);
   /* this is what you want to see */
   if(my_rank == 0)
      printf("The final result is ==> %e\n", finalsum);
   /* Release resources */
   MPI_Finalize();
}

float f(float a, float b)
{  float c = a*a + b*b;
   return c;
}
